Loading...
Searching...
No Matches
ServiceNowRestClient::ServiceNowRestConnection Class Reference

class for ServiceNow REST connections; returns ServiceNowRestClient objects More...

Inheritance diagram for ServiceNowRestClient::ServiceNowRestConnection:
[legend]

## Public Member Functions

| constructor (string name, string description, string url, hash< auto > attributes={}, hash< auto > options={})
| creates the ServiceNowRestConnection object More...
DataProvider::AbstractDataProvider | getDataProvider ()
| returns a data provider object for this connection More...
string | getType ()
| returns `"snrest"`
bool | hasDataProvider ()
| returns True as this connection returns a data provider with the getDataProvider() method More...

## Public Attributes

const | ConnectionScheme
| Connection entry info.

## Protected Member Functions

hash< ConnectionSchemeInfo > | getConnectionSchemeInfoImpl ()
| Returns the ConnectionSchemeInfo hash for this object.
ServiceNowRestClient | getImpl (bool connect=True, *hash< auto > rtopts)
| returns a ServiceNowRestClient object More...
| setChildCapabilities ()
| Sets child data provider capabilities.

## Detailed Description

class for ServiceNow REST connections; returns ServiceNowRestClient objects

supports the following options:

- `"api"`: the API version for ServiceNow
- `"client_id"`: (optional) the ServiceNow OAuth2 client ID
- `"client_secret"`: (optional) the ServiceNow OAuth2 client secret
- `"connect_timeout"`: connection timeout to use in milliseconds
- `"content_encoding"`: this sets the send encoding (if the `"send_encoding"` option is not set) and the requested response encoding; for possible values, see EncodingSupport
- `"data"`: see DataSerializationOptions for possible values; the default is `"json"`
- `"error_passthru"`: if True then HTTP status codes indicating errors will not cause a `REST-RESPONSE-ERROR` exception to be raised, rather such responses will be passed through to the caller like any other response
- `"http_version"`: HTTP version to use (`"1.0"` or `"1.1"`, defaults to `"1.1"`)
- `"max_redirects"`: maximum redirects to support
- `"proxy"`: proxy URL to use
- `"redirect_passthru"`: if True then redirect responses will be passed to the caller instead of processed
- `"send_encoding"`: a send data encoding option or the value `"auto"` which means to use automatic encoding; if not present defaults to no content-encoding on sent message bodies
- `"timeout"`: transfer timeout to use in milliseconds

See also
  ServiceNowRestClient::ServiceNowRestClient::constructor() for more information on the above options

## Member Function Documentation

## constructor()

ServiceNowRestClient::ServiceNowRestConnection::constructor | ( | string | name,
|  | string | description,
|  | string | url,
|  | hash< auto > | attributes = `{}`,
|  | hash< auto > | options = `{}`
| ) |  |

creates the ServiceNowRestConnection object

Parameters

  name | the name of the connection
  description | connection description
  url | connection URL (potentially with password info)
  attributes | various attributes. See below
  options | connection options

See ConnectionProvider::AbstractConnection::constructor() for `attributes` and `options` reference.

Exceptions

  CONNECTION-OPTION-ERROR | missing or invalid connection option

## getDataProvider()

DataProvider::AbstractDataProvider ServiceNowRestClient::ServiceNowRestConnection::getDataProvider | ( |  | ) |

returns a data provider object for this connection

Returns
  a data provider object for this connection

## getImpl()

ServiceNowRestClient ServiceNowRestClient::ServiceNowRestConnection::getImpl | ( | bool | connect = `True`,
|  | *hash< auto > | rtopts
| ) |  |

protected

returns a ServiceNowRestClient object

Parameters

  connect | if True, then the connection is returned already connected
  rtopts | this connection type does not accept any runtime options, so this parameter is ignored

Returns
  a ServiceNowRestClient object

## hasDataProvider()

bool ServiceNowRestClient::ServiceNowRestConnection::hasDataProvider | ( |  | ) |

returns True as this connection returns a data provider with the getDataProvider() method

Returns
  True as this connection returns a data provider with the getDataProvider() method

See also
  getDataProvider()